// tdb.h generated by javah. Compile with:
//
// cc                                       \
//   -shared                                \
//   -fPIC                                  \
//   -I /usr/local/include                  \
//   -I /usr/local/openjdk8/include         \
//   -I /usr/local/openjdk8/include/freebsd \
//   -L /usr/local/lib                      \
//   -ltraildb                              \
//   -o tdb.so                              \
//   tdb.c
//
// and move shared library file to lib/.
#include <string.h>
#include <traildb.h>
#include "tdb.h"

JNIEXPORT jlong JNICALL Java_contrib_io_tdb_consInitOpen
  (JNIEnv *env, jobject this, jstring jroot, jobjectArray jfields)
{
  const char  *root       = (*env)->GetStringUTFChars(env, jroot, NULL);
  const int    num_fields = (*env)->GetArrayLength(env, jfields);
  const char **fields     = malloc(num_fields * sizeof(char *));

  jobject tmp;

  for (int i = 0; i < num_fields; i++) {
    tmp       = (*env)->GetObjectArrayElement(env, jfields, i);
    fields[i] = (*env)->GetStringUTFChars(env, tmp, NULL);
  }

  // open() checks that cons != NULL
  tdb_cons *cons = tdb_cons_init();
  tdb_error err  = tdb_cons_open(cons, root, fields, num_fields);

  // free
  for (int i = 0; i < num_fields; i++) {
    tmp = (*env)->GetObjectArrayElement(env, jfields, i);
    (*env)->ReleaseStringUTFChars(env, tmp, fields[i]);
  }
  free(fields);
  (*env)->ReleaseStringUTFChars(env, jroot, root);

  // tdb_error values are < 0
  if (err) return err; else return (long) cons;
}

JNIEXPORT jint JNICALL Java_contrib_io_tdb_consFinalize
  (JNIEnv *env, jobject this, jlong jcons)
{
  tdb_cons *cons = (tdb_cons *) jcons;
  tdb_error err  = tdb_cons_finalize(cons);
  return err;
}

JNIEXPORT void JNICALL Java_contrib_io_tdb_consClose
  (JNIEnv *env, jobject this, jlong jcons)
{
  tdb_cons *cons = (tdb_cons *) jcons;
  tdb_cons_close(cons);
}

JNIEXPORT jint JNICALL Java_contrib_io_tdb_consAdd
  (JNIEnv      *env,
   jobject      this,
   jlong        jcons,
   jbyteArray   juuid,
   jlong        jtimestamp,
   jobjectArray jvalues)
{
  tdb_cons       *cons          = (tdb_cons *) jcons;
  const uint8_t   uuid[16];
  const uint64_t  timestamp     = jtimestamp;
  const int       num_values    = (*env)->GetArrayLength(env, jvalues);
  const char    **values        = malloc(num_values * sizeof(char *));
        uint64_t *value_lengths = malloc(num_values * sizeof(uint64_t));

  jobject tmp;

  (*env)->GetByteArrayRegion(env, juuid, 0, 16, (jbyte *) uuid);

  for (int i = 0; i < num_values; i++) {
    tmp              = (*env)->GetObjectArrayElement(env, jvalues, i);
    values[i]        = (*env)->GetStringUTFChars(env, tmp, NULL);
    value_lengths[i] = strlen(values[i]);
  }

  tdb_error err = tdb_cons_add(cons, uuid, timestamp, values, value_lengths);

  // free
  free(value_lengths);
  for (int i = 0; i < num_values; i++) {
    tmp = (*env)->GetObjectArrayElement(env, jvalues, i);
    (*env)->ReleaseStringUTFChars(env, tmp, values[i]);
  }
  free(values);

  return err;
}

JNIEXPORT jstring JNICALL Java_contrib_io_tdb_errorStr
  (JNIEnv *env, jobject this, jint errcode)
{
  const char *str  = tdb_error_str(errcode);
  jstring     jstr = (*env)->NewStringUTF(env, str);
  return jstr;
}

// tdb
